Attribute VB_Name = "Module2"
Option Explicit

Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function CreateToolhelp32Snapshot Lib "kernel32" (ByVal dwFlags As Long, ByVal th32ProcessID As Long) As Long
Private Declare Function OpenProcess Lib "kernel32" (ByVal dwDesiredAccess As Long, ByVal bInheritHandle As Long, ByVal dwProcessId As Long) As Long
Private Declare Function ProcessFirst Lib "kernel32" Alias "Process32First" (ByVal hSnapShot As Long, uProcess As PROCESSENTRY32) As Long
Private Declare Function ProcessNext Lib "kernel32" Alias "Process32Next" (ByVal hSnapShot As Long, uProcess As PROCESSENTRY32) As Long

Private Type PROCESSENTRY32
    dwSize As Long
    cntUsage As Long
    th32ProcessID As Long
    th32DefaultHeapID As Long
    th32ModuleID As Long
    cntThreads As Long
    th32ParentProcessID As Long
    pcPriClassBase As Long
    dwFlags As Long
    szExeFile As String * 500
End Type

Private Const PROCESS_TERMINATE = &H1 '
Private Const TH32CS_SNAPPROCESS = 2 '


Public Function GetProcessPID(sEXEName As String, Optional ByVal id As Long = 1) As Long
    Dim hPS As Long, xx As Long
    Dim pe32 As PROCESSENTRY32
    Dim buffer As String * 255, loaded As Boolean
    Dim hand As Long, EXEName As String
    Dim theloop As Long, myID As Long

    hPS = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0)

    If hPS = -1 Then Exit Function
    pe32.dwSize = Len(pe32)
    theloop = ProcessFirst(hPS, pe32)
    While theloop <> 0 '
        hand = OpenProcess(PROCESS_TERMINATE, True, CLng(pe32.th32ProcessID))
        EXEName = pe32.szExeFile
        myID = pe32.th32ProcessID
        If UCase(Left(EXEName, Len(sEXEName))) = UCase(sEXEName) Then
            xx = xx + 1
            If id = xx Then
                GetProcessPID = myID
                CloseHandle hPS
                Exit Function
            End If
        End If
        theloop = ProcessNext(hPS, pe32)
    Wend
    CloseHandle hPS
End Function

